#include <pch.h>

SDL_GPUCommandBuffer* CommandBufferAcquire(SDL_GPUDevice* device) {
    SDL_assert(device != NULL);

    SDL_GPUCommandBuffer* command_buffer = SDL_AcquireGPUCommandBuffer(device);
    LogAssertSDL(command_buffer != NULL, "Failed to acquire GPU command buffer");

    return command_buffer;
}

bool CommandBufferSubmit(SDL_GPUCommandBuffer* command_buffer) {
    SDL_assert(command_buffer != NULL);

    bool success = SDL_SubmitGPUCommandBuffer(command_buffer);
    LogAssertSDL(success, "Failed to submit command buffer");

    return success;
}
