#ifndef UPLOAD_H
#define UPLOAD_H

#include <SDL3/SDL_gpu.h>

typedef struct {
    SDL_GPUTransferBuffer* transfer_buffer;
    SDL_GPUCopyPass* copy_pass;
    SDL_GPUCommandBuffer* command_buffer;
} UploadState;

void UploadToBuffer(SDL_GPUDevice* device, const void* data, size_t byte_size, SDL_GPUBuffer* buffer);
void UploadToTexture(SDL_GPUDevice* device, SDL_Surface* surface, SDL_GPUTexture* texture);
void UploadToTextureRaw(
    SDL_GPUDevice* device, const void* pixels, int width, int height, SDL_GPUTexture* texture);

#endif
