#include <pch.h>

FileData FileRead(const char* filename, const char* mode) {
    FILE* file = fopen(filename, mode);
    if(file == NULL) {
        perror(filename);
        return (FileData){ 0 };
    }
    fseek(file, 0, SEEK_END);
    size_t length = ftell(file);
    rewind(file);

    uint8_t* buffer = malloc(length);
    if(buffer == NULL) {
        perror("Failed to allocate memory");
        return (FileData){ 0 };
    }

    size_t read_count = fread(buffer, sizeof(char), length, file);
    fclose(file);
    if(read_count != length) {
        perror("Failed to read entire file");
        return (FileData){ 0 };
    }

    return (FileData){
        .length = length,
        .data = buffer,
    };
}

FileData FileReadText(const char* filename) {
    return FileRead(filename, "r");
}

FileData FileReadBinary(const char* filename) {
    return FileRead(filename, "rb");
}

void FileFree(FileData file) {
    free(file.data);
}
